#include "area.hpp"
#include <iostream>
#include <fstream>

using namespace std;

//        .
Area::Area(ifstream &ifs) {
  ifs >> __xSize >> __ySize;
  __createRows();
  for (int j = 0; j < __ySize; j += 1) {
    __rows[j]->read(ifs);
  }
}

//   .        .
Area::Area(int _xSize, int _ySize) {
  __xSize = _xSize;
  __ySize = _ySize;
  __createRows();
}

//   __createRows    .     
//     .
void Area::__createRows() {
  __rows = new RowPtr[__ySize];
  for (int j = 0; j < __ySize; j += 1) {
    __rows[j] = new Row(__xSize);
  }
}

//         ,      .
Area::~Area() {
  for (int j = 0; j < __ySize; j += 1) {
    delete __rows[j];
  }
  delete [] __rows;
}

//  cell     . ,    
//  ,    ,     Cell::border().
Cell *Area::cell(int i, int j) const {
  if (j < 0 || j >= __ySize) {
    return Cell::border();
  } else {
    return __rows[j]->cell(i);
  }
}
  
//  show       .
void Area::show() const {
  for (int j = 0; j < __ySize; j += 1) {
    __rows[j]->show();
    cout << "\n";
  }
}

//  set       .    
//   ,    .
void Area::set(int i, int j, Cell *c) {
  __rows[j]->set(i, c);
}
