#include "cell.hpp"
#include <iostream>
#include <fstream>

using namespace std;

// - create     ,    '1',  
// ---    '0'.
Cell *Cell::create(char c) {
  switch (c) {
  case '0':
    return new DeadCell;
  case '1':
    return new LiveCell;
  default:
    throw "  ";
  }
}

// - read          
//    - create.
Cell *Cell::read(ifstream &ifs) {
  char l;
  ifs >> l;
  return create(l);
}

//   border    ,     
//  .      .      
// ,     "" (., ,
// http://cpp-reference.ru/patterns/creational-patterns/singleton/)

Cell *Cell::__border = NULL;

Cell *Cell::border() {
  if (__border == NULL) {
    __border = new DeadCell;
  }
  return __border;
}
