#ifndef __CELL_HPP__
#define __CELL_HPP__

#include <iostream>

using namespace std;

//   .

class Cell {
private:
  static Cell *__border;
public:
  // -
  static Cell *create(char);
  static Cell *read(ifstream &);

  // 
  virtual int liveness() const = 0;
  bool isLive() { return liveness() == 1; }
  static Cell *border();
  
  virtual void show() const = 0;
};

//      ,    -  .

class LiveCell: public Cell {
private:
  int liveness() const { return 1; }
  void show() const { cout << '1'; }
};

class DeadCell: public Cell {
private:
  int liveness() const { return 0; }
  void show() const { cout << '0'; }
};

#endif
