#include "exec.hpp"

//      ,      
// .           ,  
//   init.
Executor::Executor() {
  __area = NULL;
}

//    ,    .
Executor::~Executor() {
  if (__area != NULL) {
    delete __area;
  }
}

//   init  ,    ,       
// .
void Executor::init(ifstream &ifs) {
  if (__area != NULL) {
    delete __area;
  }
  __area = new Area(ifs);
}

//  __cellEnv          .
int Executor::__cellEnv(int i, int j) const {
  int result = 0;
  for (int y = -1; y <= 1; y += 1) {
    for (int x = -1; x <= 1; x += 1) {
      if (x != 0 || y != 0) {
	result += __area->cell(i + x, j + y)->liveness();
      }
    }
  }
  return result;
}

//  show       .
void Executor::show() const {
  __area->show();
}

//  step       .
void Executor::step() {
  //     ---     ,   .
  Area *buffer = new Area(__area->xSize(), __area->ySize());

  //             .
  for (int j = 0; j < __area->ySize(); j += 1) {
    for (int i = 0; i < __area->xSize(); i += 1) {
      //     cellEnv,     
      //        .
      int e = __cellEnv(i, j);
      //      ,      .
      if (__area->cell(i, j)->isLive()) {
	if (e == 2 || e == 3) {
	  buffer->set(i, j, new LiveCell);
	} else {
	  buffer->set(i, j, new DeadCell);
	}
      } else {
	if (e == 3) {
	  buffer->set(i, j, new LiveCell);
	} else {
	  buffer->set(i, j, new DeadCell);
	}
      }
    }
  }

  //       ,    
  //   .
  delete __area;
  __area = buffer;
}
