#include "area.hpp"
#include <iostream>

using namespace std;

//        .
Row::Row(int _size) {
  __size = _size;
  __cells = new CellPtr[__size];
  for (int i = 0; i < __size; i += 1) {
    __cells[i] = NULL;
  }
}

//        ,      .
Row::~Row() {
  for (int i = 0; i < __size; i += 1) {
    if (__cells[i] != NULL) {
      delete __cells[i];
    }
  }
  delete [] __cells;
}

//   read           
//  .
void Row::read(ifstream &ifs) {
  for (int i = 0; i < __size; i += 1) {
    if (__cells[i] != NULL) {
      delete __cells[i];
    }
    __cells[i] = Cell::read(ifs);
  }
}

//  cell        . ,   
//   ,    ,     Cell::border().
Cell *Row::cell(int i) const {
  if (i < 0 || i >= __size) {
    return Cell::border();
  } else {
    return __cells[i];
  }
}

//  show       .     , 
//    .
void Row::show() const {
  for (int i = 0; i < __size; i += 1) {
    if (__cells[i] == NULL) {
      cout << ' ';
    } else {
      __cells[i]->show();
    }
  }
}

//  set       .     
//  ,    .
void Row::set(int i, Cell *c) {
  if (__cells[i] != NULL) {
    delete __cells[i];
  }
  __cells[i] = c;
}
